// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	time "time"

	consolev1 "github.com/openshift/api/console/v1"
	versioned "github.com/openshift/client-go/console/clientset/versioned"
	internalinterfaces "github.com/openshift/client-go/console/informers/externalversions/internalinterfaces"
	v1 "github.com/openshift/client-go/console/listers/console/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// ConsoleCLIDownloadInformer provides access to a shared informer and lister for
// ConsoleCLIDownloads.
type ConsoleCLIDownloadInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.ConsoleCLIDownloadLister
}

type consoleCLIDownloadInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewConsoleCLIDownloadInformer constructs a new informer for ConsoleCLIDownload type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewConsoleCLIDownloadInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredConsoleCLIDownloadInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredConsoleCLIDownloadInformer constructs a new informer for ConsoleCLIDownload type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredConsoleCLIDownloadInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ConsoleV1().ConsoleCLIDownloads().List(options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ConsoleV1().ConsoleCLIDownloads().Watch(options)
			},
		},
		&consolev1.ConsoleCLIDownload{},
		resyncPeriod,
		indexers,
	)
}

func (f *consoleCLIDownloadInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredConsoleCLIDownloadInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *consoleCLIDownloadInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&consolev1.ConsoleCLIDownload{}, f.defaultInformer)
}

func (f *consoleCLIDownloadInformer) Lister() v1.ConsoleCLIDownloadLister {
	return v1.NewConsoleCLIDownloadLister(f.Informer().GetIndexer())
}
